package lbgs;
import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;
import java.util.ArrayList;
import java.util.List;

import javax.swing.DefaultListModel;
import javax.swing.JButton;
import javax.swing.JComboBox;
import javax.swing.JFrame;
import javax.swing.JLabel;
import javax.swing.JList;
import javax.swing.JPanel;
import javax.swing.JScrollPane;
import javax.swing.event.ListSelectionEvent;
import javax.swing.event.ListSelectionListener;

/*
 * _CAO{bNX̐`
 * DialogBox.java
 */

/**
 * @author lbgs
 * @version 1.1 (2005/10/30)
 */

public class DialogBox extends JFrame implements ActionListener, ListSelectionListener {
	private static final long serialVersionUID = 1L;

	public static void main(String[] args) {
        DialogBox dialog = new DialogBox();
        
        dialog.setBounds(WINDOW_X, WINDOW_Y, WINDOW_WIDTH, WINDOW_HEIGHT); //TCYƈʒuw肷
        dialog.setVisible(true); //\
    }
     
    /**************************************************
     * 萔
     **************************************************/
    //EBhE֘A
    private final static int WINDOW_X = 100;
    private final static int WINDOW_Y = 100;
    private final static int WINDOW_WIDTH = 600;
    private final static int WINDOW_HEIGHT = 600;
    
    //{^֘A
    private final int BUTTON_X = 250;
    private final int BUTTON_Y = 100;
    private final int BUTTON_WIDTH = 80;
    private final int BUTTON_HEIGHT = 20;
    private final int BUTTON_SPACE = 30; //{^̊Ԋu
    
    //Xg֘A
    private final int LIST_X = 50;
    private final int LIST_Y = 50;
    private final int LIST_WIDTH = 150;
    private final int LIST_HEIGHT = 300;
    private final int LIST_MAX_SIZE = 100;

    //x֘A
    private final int COMBO_BOX_LABEL_Y = 30;
    private final int LABEL_X = 100;
    private final int LABEL_Y = 500;
    private final int LABEL_WIDTH= 200;
    private final int LABEL_HEIGHT = 40;
    
    //R{{bNX֘A
    private final int COMBO_BOX_X = 350;
    private final int COMBO_BOX_Y = 50;
    private final int COMBO_BOX_WIDTH = 60;
    private final int COMBO_BOX_HEIGHT = 20;
    private final int COMBO_BOX_SPACE = 70;

    /**************************************************
     * GUIi
     **************************************************/ 
    //x
    private JLabel keyLabel = new JLabel("L[");
    private JLabel directionLabel = new JLabel("");
    private JLabel pixelLabel = new JLabel("ړ");
    private JLabel actionLabel = new JLabel("Ă܂");
    
    //{^
    private JButton add = new JButton(" ǉ");
    private JButton change = new JButton(" ύX");
    private JButton delete = new JButton("폜");
    
    //pl
    private JPanel panel = new JPanel();
    
    //Xg
    private DefaultListModel model = new DefaultListModel();
    private JList selectList = new JList(model);
    private JScrollPane scrollPane = new JScrollPane();
    private ListData listData;
    private List list = new ArrayList(LIST_MAX_SIZE);
    
    //R{{bNX
    private String[] keyListData = {"E", "S", "D", "X"};
    private String[] directionListData = {"", "", "", ""};
    private String[] pixelListData = {"10px", "15px", "20px"};
    private JComboBox keyComboBox = new JComboBox(keyListData);
    private JComboBox directionComboBox = new JComboBox(directionListData);
    private JComboBox pixelComboBox = new JComboBox(pixelListData);

    /**************************************************
     * \bh
     **************************************************/
    
    /**
     * RXgN^
     */
    public DialogBox() {
        inialize();
//        System.out.println(keyComboBox.getSelectedItem());
//        System.out.println(directionComboBox.getSelectedItem());
//        System.out.println(pixelComboBox.getSelectedItem());
    }
    
    /**
     * _CAO{bNX
     */
    public void inialize() {
        setTitle("ݒ");
         
        //EBhEɁCvOI
        this.setDefaultCloseOperation(JFrame.EXIT_ON_CLOSE);
  
        //eR|[lg
        inintializeLabel();
        initializeButtons();
        initializeList();
        initalizeComboBox();
        initializePanel();
    }

    /**
     * pl
     */
    private void initializePanel() {
        //CAEg𖳌ɂ
        panel.setLayout(null); 
        
        //xzu
        panel.add(keyLabel);
        panel.add(directionLabel);
        panel.add(pixelLabel);
        panel.add(actionLabel);
        
        //{^zu
        panel.add(add);
        panel.add(change);
        panel.add(delete);
        
        //Xgzu
        panel.add(scrollPane);
        
        //R{{bNXzu
        panel.add(keyComboBox);
        panel.add(directionComboBox);
        panel.add(pixelComboBox);
        
        //plzu
        getContentPane().add(panel); 
    }

    /**
     * x
     */
    private void inintializeLabel() {
        keyLabel.setBounds(COMBO_BOX_X, COMBO_BOX_LABEL_Y, COMBO_BOX_WIDTH, COMBO_BOX_HEIGHT);
        directionLabel.setBounds(COMBO_BOX_X + COMBO_BOX_SPACE, COMBO_BOX_LABEL_Y, COMBO_BOX_WIDTH, COMBO_BOX_HEIGHT);
        pixelLabel.setBounds(COMBO_BOX_X + COMBO_BOX_SPACE * 2, COMBO_BOX_LABEL_Y, COMBO_BOX_WIDTH, COMBO_BOX_HEIGHT);
        actionLabel.setBounds(LABEL_X, LABEL_Y, LABEL_WIDTH, LABEL_HEIGHT);
    }
    
    /**
     * {^
     */
    private void initializeButtons() {
        //ǉ{^
        add.setBounds(BUTTON_X, BUTTON_Y, BUTTON_WIDTH, BUTTON_HEIGHT);
        add.addActionListener(this);
        add.setActionCommand("add");
 
        //ύX{^
        change.setBounds(BUTTON_X, BUTTON_Y + BUTTON_SPACE, BUTTON_WIDTH, BUTTON_HEIGHT);
        change.addActionListener(this);
        change.setActionCommand("change");
        
        //폜{^
        delete.setBounds(BUTTON_X, BUTTON_Y + BUTTON_SPACE * 2, BUTTON_WIDTH, BUTTON_HEIGHT);
        delete.addActionListener(this);
        delete.setActionCommand("delete");
    }
    
    /**
     * Xg
     */
    private void initializeList() {
    	selectList.addListSelectionListener(this);
        scrollPane.getViewport().setView(selectList);
        scrollPane.setBounds(LIST_X, LIST_Y, LIST_WIDTH, LIST_HEIGHT);
    }
    
    /**
     * R{{bNX
     */
    private void initalizeComboBox() {
        //L[̃R{{bNX
        keyComboBox.setBounds(COMBO_BOX_X, COMBO_BOX_Y, COMBO_BOX_WIDTH, COMBO_BOX_HEIGHT);
//        keyComboBox.addActionListener(this);        
        
        //̃R{{bNX
        directionComboBox.setBounds(COMBO_BOX_X + COMBO_BOX_SPACE, COMBO_BOX_Y, COMBO_BOX_WIDTH, COMBO_BOX_HEIGHT);
//        directionComboBox.addActionListener(this);
        
        //ړʂ̃R{{bNX
        pixelComboBox.setBounds(COMBO_BOX_X + COMBO_BOX_SPACE * 2, COMBO_BOX_Y, COMBO_BOX_WIDTH, COMBO_BOX_HEIGHT);
//        pixelComboBox.addActionListener(this);
    }
    
    /**
     * ANVsꂽƂ̃Cxg
     */
    public void actionPerformed(ActionEvent e) {
    	{// {^ꂽꍇ̏
            String command = e.getActionCommand();
            
            if (command.equals("add")) { //ǉ{^̏ꍇ
            	listData = new ListData(
            		(String) keyComboBox.getSelectedItem(),
            		(String) directionComboBox.getSelectedItem(),
            		(String) pixelComboBox.getSelectedItem());
            	
                setActionLabel("ǉ{^܂");
//                model.addElement(listData.getKey() + "   "
//                        + listData.getDirection() + "   "
//                        + listData.getPixel());
                model.addElement(listData);
                
            } else if (command.equals("change")) { //ύX{^̏ꍇ
                setActionLabel("ύX{^܂");
                if (!selectList.isSelectionEmpty()){
                    int index = selectList.getSelectedIndex();
                    model.set(index, (String) keyComboBox.getSelectedItem() + "   "
                            + (String) directionComboBox.getSelectedItem() + "   "
                            + (String) pixelComboBox.getSelectedItem());
                }

            } else if (command.equals("delete")) { //폜{^̏ꍇ
                setActionLabel("폜{^܂");
                if (!selectList.isSelectionEmpty()){ //ڂI΂Ă
                    model.remove(selectList.getSelectedIndex()); //Iڂ폜
                }
            }
        }
        
//        {// R{{bNXvfI΂ꂽꍇ̏
//            if (e.getSource() == keyComboBox) { //L[̏ꍇ
//                listData[listDataIndex].setKey((String) keyComboBox.getSelectedItem());
//            } else if (e.getSource() == directionComboBox) { //̏ꍇ
//                listData[listDataIndex].setDirection((String) directionComboBox.getSelectedItem());
//            } else if (e.getSource() == pixelComboBox) { //ړʂ̏ꍇ
//                listData[listDataIndex].setPixel((String) pixelComboBox.getSelectedItem());
//            }
//        }
    }
    
    /**
     * XgIꂽƂ̃Cxg
     */
    public void valueChanged(ListSelectionEvent e) {
    	//ACxĝCŌ̂̂
		if (e.getValueIsAdjusting()){ 
			return;
		}

		JList listData = (JList)e.getSource();

		if (!listData.isSelectionEmpty()) { //XgI΂Ăꍇ
//			keyComboBox.setSelectedItem(listData[theList.getSelectedIndex()].getKey());
//			directionComboBox.setSelectedItem(listData[theList.getSelectedIndex()].getDirection());
//			pixelComboBox.setSelectedItem(listData[theList.getSelectedIndex()].getPixel());
			
			System.out.println(listData.getSelectedIndex());
            System.out.println(listData.getClass());   
            
//			setActionLabel(listData.getKey() + ", "
//					+ listData.getDirection() + ", "
//					+ listData.getPixel());
            
            setActionLabel(listData.getSelectedValue().toString());
		}
	}

    /**
     * x
     */
    public void setActionLabel(String actionLabel) {
        this.actionLabel.setText(actionLabel);
    }
}
