/*
 * 쐬: 2005/07/14
 *
 * TODO ̐ꂽt@C̃ev[gύXɂ͎փWv:
 * EBhE - ݒ - Java - R[hEX^C - R[hEev[g
 */
package note;

import java.awt.Font;
import java.awt.Insets;
import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;
import java.awt.event.InputEvent;
import java.awt.event.KeyEvent;

import javax.swing.JButton;
import javax.swing.JLabel;
import javax.swing.JPanel;

/**
 * @author Shino
 * 
 * t@NVpl̐ݒ
 */
public class FunctionPanel extends JPanel implements ActionListener {
	/***************************************************************************
	 * 萔
	 **************************************************************************/
	private static final long serialVersionUID = 1L;
	private static final int FUNCTION_KEY_SIZE = 12;
	private static final int[] FUNCTION_KEY_CODE = { 0, KeyEvent.VK_F1,
			KeyEvent.VK_F2, KeyEvent.VK_F3, KeyEvent.VK_F4, KeyEvent.VK_F5,
			KeyEvent.VK_F6, KeyEvent.VK_F7, KeyEvent.VK_F8, KeyEvent.VK_F9,
			KeyEvent.VK_F10, KeyEvent.VK_F11, KeyEvent.VK_F12 };
	
	// {^GUIݒ
	private static final Font LABEL_FONT = new Font("", Font.PLAIN, 10);
	private static final Insets BUTTON_INSETS = new Insets(2, 8, 2, 8);


	/***************************************************************************
	 * ϐ
	 **************************************************************************/
	private JButton[] button = new JButton[FUNCTION_KEY_SIZE];
	private NoteApplication listener;

	/**
	 * RXgN^
	 * 
	 * @param listener
	 */
	public FunctionPanel(NoteApplication listener) {
		this.listener = listener;

		// {^
		for (int i = 0; i < button.length; i++) {
			// {^
			button[i] = createButton(i + 1);
			this.add(button[i]);

			// Ԃ
			if ((i + 1) % 4 == 0 && i != 11) {
				this.add(new JLabel(" "));
			}
		}
	}

	/*
	 * plɓ\t{^B
	 */
	private JButton createButton(int number) {
		JButton button = new JButton("F" + number);
		button.addActionListener(this);
		button.setActionCommand(String.valueOf(number));
		button.setFont(LABEL_FONT);
		button.setMargin(BUTTON_INSETS);

		// tH[JX擾Ȃݒɂ
		button.setRequestFocusEnabled(false);
		return button;
	}

	/**
	 * t@NV{^̖Oݒ肷B
	 * 
	 * @param index t@NVԍ
	 * @param label O
	 */
	public void setFunctionName(int index, String label) {
		button[index - 1].setLabel(label);
	}

	/*
	 * @see java.awt.event.ActionListener#actionPerformed(java.awt.event.ActionEvent)
	 */
	public void actionPerformed(ActionEvent e) {

		// {^ꂽƂ̏CL[擾
		int modifiers;
		// TODO Ă̂킩Ȃ
		if ((e.getModifiers() & InputEvent.BUTTON1_MASK) != 0) {
			modifiers = e.getModifiers() - InputEvent.BUTTON1_MASK;
		} else {
			modifiers = e.getModifiers();
		}

		// ꂽ{^̔ԍkeyCode擾
		int number = Integer.parseInt(e.getActionCommand());
		int keyCode = FUNCTION_KEY_CODE[number];// FL[̃L[R[h

		// ꂽ{^ƏCL[ɑΉR}hs
		if (number >= 1 && number <= FUNCTION_KEY_SIZE) {
			listener.executeFunction(keyCode, modifiers);
		} else {
			throw new RuntimeException("FL[̎wԍsł");
		}
	}
}
