package note;

import java.awt.Graphics;
import java.awt.Toolkit;
import java.awt.event.MouseAdapter;
import java.awt.event.MouseEvent;
import java.net.URL;

import javax.swing.JPanel;
import javax.swing.JWindow;

/**
 * ̂Ƃ̃XvbVEBhE
 * 
 * @author Kazuhiro Kurashige
 */
public class NoteSplashWindow extends JWindow {

	/** c[Lbg */
	private final Toolkit toolkit = Toolkit.getDefaultToolkit();

	/** 摜̕ */
	private final int WIDTH = 432;

	/** 摜̍ */
	private final int HEIGHT = 316;

	/** XvbVEBhEXʒu */
	private final int LOCATION_X = (int) toolkit.getScreenSize().getWidth() / 2
			- WIDTH / 2;

	/** XvbVEBhEYʒu */
	private final int LOCATION_Y = (int) toolkit.getScreenSize().getHeight() / 2
			- HEIGHT / 2;

	/** C[WURL */
	public static final URL imageURL = ClassLoader
			.getSystemResource("resources/img/splashImage/splash.gif");

	/**
	 * XvbVEBhE\B
	 */
	public final void splash() {
		setLocation(LOCATION_X, LOCATION_Y);
		setSize(WIDTH, HEIGHT);

		addMouseListener(new MouseAdapter() {
			public void mouseClicked(MouseEvent e) {
				setVisible(false);
			}
		});

		getContentPane().add(new JPanel() {
			public void paintComponent(Graphics g) {
				super.paintComponents(g);
				g.drawImage(toolkit.getImage(imageURL), 0, 0, this);
			}
		});

		setVisible(true);
	}
	
	/**
	 * XvbVEChEB
	 */
	public final void close(){
		setVisible(false);
	}

}
