/*
 * Created on 2006/01/12
 *
 * Copyright (c) 2005 Nooto Poject.  All rights reserved.
 */
package note.command;

import java.awt.Dimension;
import java.util.List;

import note.NoteApplication;
import note.model.Group;
import note.model.Picture;
import note.model.PictureGroup;

/**
 * Class ElementSelectCommand
 * ĂȂB
 * @author user
 * @version $Id: ElementSelectCommand.java,v 1.4 2006/02/03 22:29:55 camei Exp $
 */
public class ElementSelectCommand extends AbstractCommand {

	/***************************************************************************
	 * 萔
	 **************************************************************************/
	public static final int NORMAL = 1;
	public static final int ADD = 2;
	public static final int EXCEPT = 3;
	private static final Dimension RANGE = new Dimension(5, 5);// e͈

	/***************************************************************************
	 * ϐ
	 **************************************************************************/
	private int x;
	private int y;
	private int option;

	/**
	 * RXgN^B
	 * 
	 * @param reciever V[o
	 * @param x NbNWx
	 * @param y NbNWy
	 * @param option IIvV
	 */
	public ElementSelectCommand(NoteApplication reciever, int x, int y,
			int option) {
		super(reciever);
		this.x = x;
		this.y = y;
		this.option = option;
	}

	/**
	 * @see note.command.AbstractCommand#clone()
	 */
	public Object clone() {
		return this;
	}

	/**
	 * @return ݎs\
	 * @see note.command.AbstractCommand#canExecute()
	 */
	public boolean canExecute() {
		return true;
	}

	public void execute() {

		// }`I
		if (!selectIntersectsPicture(x, y)) {// I}`Ȃꍇ
			// eLXgNbNǂׂ
			if (!selectIntersectsText(x, y)) {// IeLXgȂꍇ

				// wiNbNƂ݂Ȃ
				if (option == NORMAL) {// ʏȈꍇ
					// SĂ̑I
					releaseAllSelection();
				}
			}
		}
		repaint();
	}

	/*
	 * w肵Wɂ}`IB @return I
	 */
	private boolean selectIntersectsPicture(int x, int y) {
		List pictureGroupList = getCurrentPage().getPictureGroupList();
		for (int i = 0; i < pictureGroupList.size(); i++) {
			PictureGroup pictureGroup = (PictureGroup) pictureGroupList.get(i);
			List pictureList = pictureGroup.getPictureList();
			for (int j = 0; j < pictureList.size(); j++) {
				Picture picture = (Picture) pictureList.get(j);
				int px = x - pictureGroup.getX();// }`O[vW
				int py = y - pictureGroup.getY();
				System.out.println("check" + picture.getName() + "x=" + px
						+ "y=" + py);
				if (picture.getShape().intersects(px, py, RANGE.width,
						RANGE.height)) {// }`NbNꍇ
					// NbN}`I
					selectPicture(pictureGroup, picture);
					return true;
				}
			}
		}
		return false;
	}

	/*
	 * w肵}`IB
	 */
	private void selectPicture(PictureGroup pictureGroup, Picture picture) {
		if (option == NORMAL) {// ʏȈꍇ
			// w肵}`݂̂I
			releaseAllSelection();
//			pictureGroup.selectPicture(picture);
		} else if (option == ADD) {// ǉȈꍇ
			// w肵}`I͈͂ɒǉ
//			pictureGroup.selectPicture(picture);
		} else if (option == EXCEPT) {// OȈꍇ
			// w肵}`I͈͂珜O
//			pictureGroup.unselectPicture(picture);
		}
	}

	/*
	 * w肵WɂeLXgIB
	 */
	private boolean selectIntersectsText(int x2, int y2) {
		return false;
	}

	/*
	 * SĂ̑I͈͂
	 */
	private void releaseAllSelection() {
		// SẴO[v̑I
		List goupList = getCurrentPage().getGroupList();
		for (int i = 0; i < goupList.size(); i++) {
			Group group = (Group) goupList.get(i);
			group.getEditor().clearSelection();
		}
	}

	/**
	 * @see note.command.AbstractCommand#isUndoableEdit()
	 */
	public boolean isUndoableEdit() {
		return false;
	}

}
