/**
 * 
 */
package note.model.picture;

import java.util.ArrayList;
import java.util.Arrays;
import java.util.Collection;
import java.util.HashSet;
import java.util.Iterator;
import java.util.Set;

import note.model.Picture;

/**
 * ̐}`B<br>
 * ̐}`̐}`ƂĈ߂̃NXB
 * TODO ܂Bg܂B
 * 
 * @author camei
 * @version $Id: CompoundPicture.java,v 1.1 2006/01/25 11:56:16 camei Exp $
 */
public class CompoundPicture extends Picture {

	private static final int INFINITE_DISTANCE = 9999;
	private Set pictures;

	public CompoundPicture(Collection pictures) {
		this.pictures = new HashSet(pictures);
		initialize();
	}

	private void initialize() {
		// ݌vݒ肷
		
//		points; // SĂ̓_
//		lines; // SĂ̐i͑SĂ̓_indexŎw肳j
//		beginPos = -1;// SĂ̓_̎n_index
//		endPos = -1;// SĂ̓_̏I_index
//		controlsPos;// SĂ̓_̑_index
//		selection
//
//		// ̑ݒ肷
//		{// ҏW_ݒ肷
//			begin = getBegin(pictures);
//			end = getEnd(pictures);
//
//			Collection compoundControl = new ArrayList();
//			for (Iterator i = pictures.iterator(); i.hasNext();) {
//				Picture picture = (Picture) i.next();
//				compoundControl.addAll(Arrays.asList(picture.controls));
//			}
//			controls = (PicturePoint[]) compoundControl.toArray(controls);
//		}
//
//		isInitialize = true;// ̉

	}

	/**
	 * @see note.model.Picture#cloneTemp()
	 */
	public Object clone() {
		Collection clonePictures = new HashSet();
		for (Iterator i = pictures.iterator(); i.hasNext();) {
			Picture picture = (Picture) i.next();
			clonePictures.add((Picture) picture.clone());
		}
		return new CompoundPicture(clonePictures);
	}

	/*
	 * }`B̍ŐeB߂BPictureNXCollectionw肷邱ƁB
	 */
	private Set getFirsts(Collection pictures) {
		// Ƃ̐e߂
		Set firsts = new HashSet();
		for (Iterator i = pictures.iterator(); i.hasNext();) {
			Picture picture = (Picture) i.next();

			// }`OHāAŏ̐}`
			Picture first = picture;
			while (true) {
				if (first.hasParent() && pictures.contains(first.getParent())) {// w肳ꂽWőO̐}`ꍇ
					first = first.getParent();
					continue;
				} else {
					break;
				}
			}

			// ŏ̐}`ۑ
			firsts.add(first);
		}

		return firsts;
	}

	/*
	 * }`B̍Ŏn_߂B
	 */
	private PicturePoint getBegin(Collection pictures) {
		// 擪̐}`߂
		Set firsts = getFirsts(pictures);

		// Ƃ̎n_߂
		PicturePoint[] begins = new PicturePoint[firsts.size()];
		int i = 0;
		for (Iterator iter = firsts.iterator(); iter.hasNext();) {
			begins[i] = ((Picture) iter.next()).getBeginPoint();
			i++;
		}

		// Ŝ̎n_߂
		PicturePoint begin = null;
		if (begins.length > 1) {// Ƃ̎n_ꍇ
			// łɂ̂n_Ƃ
			double minX = INFINITE_DISTANCE;
			for (int j = 0; j < begins.length; j++) {
				if (begins[j].getX() < minX) {
					minX = begins[j].getX();
					begin = begins[j];
				}
			}

		} else if (begins.length == 1) {// Ƃ̎n_1݂̂̏ꍇ
			begin = begins[0];

		} else {// G[
			throw new Error("O[v̎n_߂܂");
		}

		return begin;
	}

	/*
	 * }`B̍ŏI_߂B
	 */
	private PicturePoint getEnd(Collection pictures) {
		return null;
	}

	public String getName(){
		return "CompoundPicture";
	}
}
