/*
 * Created on Jun 30, 2005
 *
 * Copyright (c) 2005 Nooto Poject.  All rights reserved.
 */
package note.model;

import java.awt.print.PageFormat;
import java.awt.print.Printable;
import java.io.Serializable;
import java.util.ArrayList;
import java.util.List;

import note.viewer.NoteProcessorPane;

/**
 * Class Note
 * 
 * m[gNX
 * 
 * TODO moveninsert̃\bhPageԂKv͂̂HȂΏĂ܂
 * 
 * @author lbgs
 * @version $Id: Note.java,v 1.10 2006/02/09 02:14:29 tajifu Exp $
 */
public class Note implements Serializable{

	/***************************************************************************
	 * ϐ
	 **************************************************************************/
	// private NoteApplication noteApplication; //
	// PageNX֓n߂NoteApplication`̃f[^ێ
	private transient NoteProcessorPane noteChangedListener;// m[g̕ύX𕷂Xi[

	private String title;
	private List pageList = new ArrayList(); // y[W
	private NoteStyle noteStyle = new NoteStyle();
	private int currentPageIndex = 0;
	
	/**
	 * RXgN^
	 */
	public Note(/* NoteApplication noteApplication */) {
		// this.noteApplication = noteApplication; // NoteApplication󂯎
		pageList.add(createPage()); // ŏ̃y[W쐬
	}

	/**
	 * y[WXg߂
	 */
	public List getPageList() {
		return new ArrayList(pageList);
	}

	/**
	 * ύXʒm郊Xi[ǉ
	 * 
	 * @param listener
	 */
	public void addNoteChangedListener(NoteProcessorPane listener) {
		noteChangedListener = listener;
	}

	/**
	 * Õy[Wֈړ
	 */
	public Page movePreviousPage() {
		if (currentPageIndex > 0) {
			currentPageIndex--;
		}

		noteChangedListener.updatePage();
		return (Page) pageList.get(currentPageIndex);
	}

	/**
	 * ̃y[Wֈړ
	 */
	public Page moveNextPage() {
		if (currentPageIndex == pageList.size() - 1) {
			pageList.add(createPage());
		}
		currentPageIndex++;

		noteChangedListener.updatePage();
		return (Page) pageList.get(currentPageIndex);
	}

	/**
	 * w肵y[WɈړ
	 * @param page łɂ̃m[gɂړ̃y[W
	 */
	public void movePage(Page page){
		if(pageList.contains(page)){
			// w肵y[WɈړ
			currentPageIndex =  pageList.lastIndexOf(page);
			
			noteChangedListener.updatePage();

		} else {
			throw new RuntimeException("y[W̎w肪sł");
		}
	}
	
	/**
	 * y[W}āC̃y[Wւƈړ TODO ̃\bh͏璷
	 */
	public Page insertAndMovePage() {
		insertPage(currentPageIndex + 1, createPage());
		currentPageIndex++;
		noteChangedListener.updatePage();
		return (Page) pageList.get(currentPageIndex);
	}

	/**
	 * Ŏw肳ꂽCfbNXɁCœnꂽy[Wǉ
	 */
	public void insertPage(int index, Page page) {
		pageList.add(index, page);
		if (currentPageIndex > index) { // }ʒũ݂y[WOꍇ
			currentPageIndex++;
		}
		noteChangedListener.updatePage();
	}

	/**
	 * y[W폜
	 * @param page 폜y[W
	 * @return 폜łꍇ<code>true</code>߂B
	 */
	public boolean removePage(Page page){
		return pageList.remove(page);
	}
	
	/*
	 * Vy[W𐶐
	 */
	private Page createPage() {
		Page page = new Page();
		return page;
	}

	/***************************************************************************
	 * Getter & Setter
	 **************************************************************************/
	
	/**
	 * @return ݂̃y[W
	 */
	public Page getCurrentPage() {
		return (Page) pageList.get(currentPageIndex);
	}

	/**
	 * @return ݂̃^Cg
	 */
	public String getTitle() {
		return title;
	}

	/**
	 * @param title
	 */
	public void setTitle(String title) {
		this.title = title;
	}

	/**
	 * @return m[g̃tH[}bg
	 */
	public NoteStyle getNoteStyle() {
		return noteStyle;
	}

	/**
	 * @return ݂̃y[W
	 */
	public int getCurrentPageIndex() {
		return currentPageIndex;
	}
	
	/**
	 * @return ݂̑y[W
	 */
	public int getNumberOfTotalPages() {
		return pageList.size();
	}

}
