/*
 * Created on 2006/01/18
 *
 * Copyright (c) 2005 Nooto Poject.  All rights reserved.
 */
package note.model;

import java.io.Serializable;

import javax.swing.text.AbstractDocument;
import javax.swing.text.DefaultStyledDocument;
import javax.swing.text.Position;
import javax.swing.text.StyledDocument;
import javax.swing.text.StyledEditorKit;

/**
 * Class TextElement ꂽeLXgvfB
 * 
 * @author user
 * @version $Id: TextElement.java,v 1.2 2006/01/31 11:04:52 tajifu Exp $
 */
public class TextElement extends AbstractElement {

	private StyledDocument document;// ΏۂStyledDocument
	private Position begin;
	private Position end;
	private DefaultStyledDocument.ElementSpec data;
	private TextGroup parentGroup = null;
	
	/**
	 * RXgN^B
	 * @param document document
	 * @param begin JnPosition
	 * @param end IPosition
	 */
	public TextElement(StyledDocument document, Position begin, Position end) {
		this.document = document;
		this.begin = begin;
		this.end = end;
	}
	
	
	

	/***************************************************************************
	 * Getter & Setter
	 **************************************************************************/

	/**
	 * 
	 * @return document
	 */
	public StyledDocument getDocument() {
		return document;
	}

	/**
	 * Returns the begin.
	 * @return begin
	 */
	public Position getBegin() {
		return begin;
	}

	/**
	 * Returns the end.
	 * @return end
	 */
	public Position getEnd() {
		return end;
	}

	/**
	 * Returns the parentGroup.
	 * @return Returns the parentGroup.
	 */
	public Group getParentGroup() {
		return parentGroup;
	}

	/**
	 * Sets the parentGroup.
	 * @param parentGroup The parentGroup to set.
	 */
	public void setParentGroup(TextGroup parentGroup) {
		this.parentGroup = parentGroup;
	}
	
	

}
