/*
 * Created on 2006/02/06
 *
 * Copyright (c) 2005 Nooto Poject.  All rights reserved.
 */
package note.model;

import java.awt.datatransfer.DataFlavor;
import java.awt.datatransfer.Transferable;
import java.awt.datatransfer.UnsupportedFlavorException;
import java.io.IOException;
import java.util.ArrayList;
import java.util.List;

/**
 * O[vB\f[^^B
 * 
 * @author camei
 * @version $Id: TransferableGroupData.java,v 1.1 2006/02/06 20:13:02 camei Exp $
 */
public class TransferableGroupData implements Transferable {
	public static final DataFlavor GROUP_FLAVOR = new DataFlavor(
			TransferableGroupData.class, "group");// TODO

	private static final DataFlavor[] SUPPORT_FLAVORS = new DataFlavor[] { GROUP_FLAVOR };
	private Group[] groups;

	/**
	 * RXgN^B
	 * 
	 * @param groupList O[vB
	 */
	public TransferableGroupData(List groupList) {
		// O[v̕ĕێ
		groups = new Group[groupList.size()];
		groups = (Group[]) groupList.toArray(groups);
		groups = cloneGroups(groups);
	}

	/*
	 * O[v𕡐B
	 */
	private Group[] cloneGroups(Group[] groups){
		Group[] cloneGroups = new Group[groups.length];
		for (int i = 0; i < groups.length; i++) {
			cloneGroups[i] = (Group) groups[i].clone();
		}
		return cloneGroups;		
	}

	/*
	 * @see java.awt.datatransfer.Transferable#getTransferDataFlavors()
	 */
	public DataFlavor[] getTransferDataFlavors() {
		return SUPPORT_FLAVORS;
	}

	/*
	 * @see java.awt.datatransfer.Transferable#isDataFlavorSupported(java.awt.datatransfer.DataFlavor)
	 */
	public boolean isDataFlavorSupported(DataFlavor flavor) {
		return flavor.equals(GROUP_FLAVOR);
	}

	/*
	 * @see java.awt.datatransfer.Transferable#getTransferData(java.awt.datatransfer.DataFlavor)
	 */
	public Object getTransferData(DataFlavor flavor)
			throws UnsupportedFlavorException, IOException {
		if(flavor.equals(GROUP_FLAVOR)){
			return cloneGroups(groups);
		} else {
			// TODO nullł͂ȂAK؂ȗOX[
			return null;
		}
	}

}
