/*
 * 쐬: 2005/07/19
 *
 * TODO ̐ꂽt@C̃ev[gύXɂ͎փWv:
 * EBhE - ݒ - Java - R[hEX^C - R[hEev[g
 */
package note.model.picture;

import java.awt.Point;
import java.awt.Rectangle;
import java.awt.Shape;
import java.awt.geom.GeneralPath;
import java.awt.geom.Point2D;

import note.model.Picture;

/**
 * g}`̐݌v}B<br>
 * g̐͐}`̊g嗦ɂĕωB
 * 
 * @author camei
 * @version $Id: UnderWaveLine.java,v 1.1 2006/01/25 11:56:16 camei Exp $
 */
public class UnderWaveLine extends PictureDesign {

	/***************************************************************************
	 * 萔
	 **************************************************************************/
	private static final long serialVersionUID = 1L;
	private static final int ZURE = 1;

	/***************************************************************************
	 * ϐ
	 **************************************************************************/
	private int width;// g
	private int height;// Ï捂
	private int waveHeight;// g̍
	private int waveNumber;// ǧJԂ

	/**
	 * RXgN^B<br>
	 * 
	 * @param width 
	 * @param height 
	 * @param waveHeight 1̔g̍
	 * @param waveNumber g̐
	 */
	public UnderWaveLine(int width, int height, int waveHeight, int waveNumber) {
		super();

		this.width = width;
		this.height = height;
		this.waveHeight = waveHeight;
		this.waveNumber = waveNumber;

		setName("UnderWaveLine");

		// ׂĂ̓_i̓_j
		Point2D[] points = new Point[] { new Point(0, 0), // left(begin)
				new Point(width, 0), // right(end)
				new Point(width, height / 2), // rightBottom
				new Point(width / 2, height / 2), // bottom
				new Point(0, height / 2), // leftBottom
		};
		setPoints(points);
		setBeginPos(0); // _
		setEndPos(1); // E_
		setControlsPos(new int[] { 2, 3, 4 }); // _CfbNX

		// ΉI͈͂
		setSelection(new Rectangle(0, -height / 2, width, height - ZURE));// B삵Ȃ
	}

	/**
	 * @return }`݌v}̃Rs[
	 * @see java.lang.Object#clone()
	 */
	public Object clone() {
		return new UnderWaveLine(width, height, waveHeight, waveNumber);
	}

	/**
	 * @return ̐݌v}ɑΉ}`𐶐B
	 * @see note.model.picture.PictureDesign#createPicture()
	 */
	protected Picture createPicture() {
		return new UnderWave(this);
	}

	/**
	 * 
	 * Class UnderWave
	 * 
	 * @author camei
	 * @version $Id: UnderWaveLine.java,v 1.1 2006/01/25 11:56:16 camei Exp $
	 */
	private class UnderWave extends Picture {

		private static final long serialVersionUID = 1L;

		public UnderWave(UnderWaveLine design) {
			super(design);
		}

		public Shape getShape() {
			UnderWaveLine design = (UnderWaveLine) getDesign();

			// g\vfvZ
			int waveNumberForSelection = (int) (waveNumber * this.scale
					.getScaleX());// xg嗦g̐𑝂₷

			// Pgi`j̗vfvZ
			float waveWidthQuorter = ((float) design.width / waveNumberForSelection) / 3;
			float waveHeight = (float) (design.waveHeight
					/ this.scale.getScaleY() / 2);

			// g
			GeneralPath path = new GeneralPath();// ǧ`
			path.moveTo((float) design.getPoints()[4].getX(), (float) design
					.getPoints()[4].getY());// g̕`Jn_Ɉړ
			// g񐔕A
			float x;// pX̍Ōɒǉꂽ|CgxW
			float y;// pX̍Ōɒǉꂽ|CgyW
			for (int i = 0; i < waveNumberForSelection; i++) {
				x = (float) path.getCurrentPoint().getX();
				y = (float) path.getCurrentPoint().getY();
				path.curveTo(x + waveWidthQuorter, y - waveHeight, x
						+ waveWidthQuorter * 2, y + waveHeight, x
						+ waveWidthQuorter * 3, y);// Pg
			}

			// ϊWKp
			path.transform(getTransform());
			return path;
		}
	}
}
